/*==========================================*/
/*  HP104D-CPD360 series					*/
/*	Library lebel1a function for Visual C	*/
/*											*/
/*	    file name:hubcp36l.h				*/
/*						 					*/
/*	Copyright(C) 2004  Hivertec Inc.		*/
/*	All Rights Reserved.					*/
/*==========================================*/
// 萔`
#define CP36_ELSPOL	0x20
#define CP36_DLSSEL	0x22
#define CP36_CP4OUT	0x24
#define CP36_CP5OUT	0x26
#define CP36_CMJOUT	0x28
#define CP36_CMPSEL	0x2a
#define CP36_INP1	0x2c
#define CP36_INP2	0x2e
#define CP36_OUTP1	0x30
#define CP36_OUTP2	0x32
#define CP36_LTCSEL	0x34
#define CP36_CLRSEL	0x36
#define CP36_OPTRST	0x3a
#define CP36_INT	0x3e


// Cu֐vg^Cv錾
#ifdef __cplusplus
extern "C"
{
#endif

DWORD hubcp364_GetDevInfo( DWORD*, HUBDEVINFO* );
DWORD hubcp364_DevOpen( DWORD*, HUBDEVINFO* );
DWORD hubcp364_DevClose( DWORD );

DWORD hubcp364_SetOrgMode( DWORD, WORD, WORD );
DWORD hubcp364_SetEls( DWORD, WORD, WORD, WORD );
DWORD hubcp364_SetOls( DWORD, WORD, WORD );
DWORD hubcp364_SetSvAlm( DWORD, WORD, WORD, WORD );
DWORD hubcp364_SetEz( DWORD, WORD, WORD, WORD );
DWORD hubcp364_SetSls( DWORD, WORD, long, long, WORD, WORD );
DWORD hubcp364_SetCmdPulse( DWORD, WORD, WORD );
DWORD hubcp364_SetAccProfile( DWORD, WORD, WORD );
DWORD hubcp364_SetAutoDec( DWORD, WORD, WORD );
DWORD hubcp364_mSetDls( DWORD, WORD, WORD, WORD, WORD );
DWORD hubcp364_mSetLtc( DWORD, WORD, WORD, WORD );
DWORD hubcp364_mSetInpos( DWORD, WORD, WORD, WORD );
DWORD hubcp364_mSetSvCtrCl( DWORD, WORD, WORD, WORD );

DWORD hubcp364_ReadMainSts( DWORD, WORD, WORD* );
DWORD hubcp364_ReadErrorSts( DWORD, WORD, DWORD* );
DWORD hubcp364_ReadEventSts( DWORD, WORD, DWORD* );
DWORD hubcp364_ReadSubSts( DWORD, WORD, WORD* );
DWORD hubcp364_ReadExSts( DWORD, WORD, DWORD* );
DWORD hubcp364_ReadIpSts( DWORD, DWORD* );
DWORD hubcp364_ReadSpd( DWORD, WORD, WORD* );
DWORD hubcp364_ReadCtr( DWORD, WORD, WORD, long* );
DWORD hubcp364_ReadLtc( DWORD, WORD, WORD, long* );

DWORD hubcp364_SetFLSpd( DWORD, WORD, DWORD );
DWORD hubcp364_SetAuxSpd( DWORD, WORD, DWORD );
DWORD hubcp364_SetAccRate( DWORD, WORD, DWORD );
DWORD hubcp364_SetDecRate( DWORD, WORD, DWORD );
DWORD hubcp364_SetMult( DWORD, WORD, DWORD );
DWORD hubcp364_SetEventMask( DWORD, WORD, DWORD );
DWORD hubcp364_SetDecPoint( DWORD, WORD, long );

DWORD hubcp364_WritOpeMode( DWORD, WORD, WORD );
DWORD hubcp364_WritFHSpd( DWORD, WORD, DWORD );
DWORD hubcp364_WritPos( DWORD, WORD, long );
DWORD hubcp364_WritLine( DWORD, WORD, long );
DWORD hubcp364_WritCircl( DWORD, WORD, long, long, long, long );
DWORD hubcp364_WritCtr( DWORD, WORD, long, WORD );

DWORD hubcp364_DecStop( DWORD, WORD );
DWORD hubcp364_QuickStop( DWORD, WORD );
DWORD hubcp364_EmgStop( DWORD, WORD );
DWORD hubcp364_AccStart( DWORD, WORD );
DWORD hubcp364_CnstStartFH( DWORD, WORD );
DWORD hubcp364_CnstStartFL( DWORD, WORD );
DWORD hubcp364_CnstStartByDec( DWORD, WORD );
DWORD hubcp364_SvOn( DWORD, WORD );
DWORD hubcp364_SvOff( DWORD, WORD );
DWORD hubcp364_SvResetOn( DWORD, WORD );
DWORD hubcp364_SvResetOff( DWORD, WORD );
DWORD hubcp364_PMOn( DWORD, WORD );
DWORD hubcp364_PMOff( DWORD, WORD );
DWORD hubcp364_CalAccRate( DWORD*, DWORD, DWORD, DWORD, WORD, WORD );

DWORD hubcp364_ReadInNo ( DWORD, WORD, WORD* );
DWORD hubcp364_ReadOutNo( DWORD, WORD, WORD* );
DWORD hubcp364_WritOutNo( DWORD, WORD, WORD );

#ifdef __cplusplus
}
#endif
