///////////////////////////////////////////////////////////
//  HP104D-CPD364										
//	Library lebel1a Functions For Visual C				
// Copyright(C) 2004  Hivertec Inc. All Rights Reserved.
///////////////////////////////////////////////////////////
#include	<windows.h>
#include	"hubcp360.h"
#include	"hubcp36l.h"

// ԍ
#define X_AX			0
#define Y_AX			1
#define Z_AX			2
#define U_AX			3

#define ILL_PRM		0x0100
#define ILL_HNDL	0xffffffff

//
//	샂[hffe[u	1:
//
WORD mod_tbl[128] = {
//  x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 xa xb xc xd xe xf
	 1, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0,	// 00-0f
	 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0,	// 10-1f
	 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0,	// 20-2f
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	// 30-3f
	 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0,	// 40-4f
	 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,	// 50-5f
	 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	// 60-6f
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0		// 70-7f
};

///////////////////////////////////////////////////////////////
//
// foCX֌W̊֐
//
///////////////////////////////////////////////////////////////

//
// foCX̃I[vCfoCX̏							
// 		FfoCXnh̃AhX
//			FfoCX̃AhX
//
DWORD hubcp364_DevOpen( DWORD* hDeviceID, HUBDEVINFO* hDevInfo )
{
	WORD	wAx;			// 
	DWORD	hDevID;			// foCXnh
	DWORD	dwRet;			// ߂l

	// foCX̃I[v
	dwRet  = ubcp360_OpenDevice( &hDevID, hDevInfo );
	if( dwRet ) {
		*hDeviceID = ILL_HNDL;
		return dwRet;
	}

	dwRet |= ubcp360_wPortB( hDevID, CP36_OPTRST, 0x00 );		// IvV|[g
	dwRet |= ubcp360_wPortB( hDevID, CP36_ELSPOL, 0x00 );		// ELSɐI|[g(B)
	dwRet |= ubcp360_wPortB( hDevID, CP36_DLSSEL, 0x00 );		// INx/DR/PCS/DLSI|[g(INx)
	dwRet |= ubcp360_wPortB( hDevID, CP36_CP4OUT, 0x00 );		// Rp[^4o͐ؑփ|[g(o͕s)
	dwRet |= ubcp360_wPortB( hDevID, CP36_CP5OUT, 0x00 );		// Rp[^5o͐ؑփ|[g(o͕s)
	dwRet |= ubcp360_wPortB( hDevID, CP36_LTCSEL, 0x00 );		// INPOS/ėp͑I|[g(INPOS)
	
	dwRet |= ubcp360_wCmdW ( hDevID, X_AX, 0x04 );				// \tgEFAZbg
	for ( wAx = X_AX; wAx < 4; wAx++ ) {
		dwRet |= ubcp360_wReg( hDevID, wAx, 0x81, 200 );		// x[XxWX^:PRFL = 200
		dwRet |= ubcp360_wReg( hDevID, wAx, 0x82, 2000 );		// 쑬xWX^:PRFH = 2000
		dwRet |= ubcp360_wReg( hDevID, wAx, 0x83, 1364 );		// [gWX^
																	// 	NbNg = 19,660,800Hz, 
																	//	 =  = 0.5b 
																	// 	PRFH = 2000, PRFL = 200, PRUR:[g
																	// 	(b)=(PRFH-PRFL)*(PRUR+1)*4/19660800
																	// 	PRUR = 1364
		dwRet |= ubcp360_wReg( hDevID, wAx, 0x85, 299 );		// {ݒ背WX^:{ = 1{
																	//  PRMG = 299
		dwRet |= ubcp360_wReg( hDevID, wAx, 0x87, 0x08008000 );	// 샂[hWX^
																	//  I_Cx萧ONC+A
																	//  PRMD = 0x8008000
		dwRet |= ubcp360_wReg( hDevID, wAx, 0x9b, 200 );		// ړʕ␳xWX^:RFA = 200
		dwRet |= ubcp360_wReg( hDevID, wAx, 0x9c, 0x20c34004 );	// ݒ1WX^:RENV1 = 0x20c34004
																	//  wߏo:ʃpXw߂̐_
																	// 	OLS & DLS & SVALM = B
																	//  INPOS & LATCH = A
																	// 	ELS & SVALM͎~
																	//  DLSo = ̂,ׯȂ
																	// 	΍رo͂Ȃ
		dwRet |= ubcp360_wReg( hDevID, wAx, 0x9d, 0x0020fd65 );	// ݒ2WX^:RENV2 = 0x0020fd65
		dwRet |= ubcp360_wReg( hDevID, wAx, 0x9e, 0x00f00002 );	// ݒ3WX^:RENV3 = 0x00f00002
																	// 	_AFݻ+ݺތ_A(OLS+Z)
																	// 	CLROFFON & _Aر
		dwRet |= ubcp360_wReg( hDevID, wAx, 0xac, 1 );			// Cxgݒ背WX^:RIRQ = 1(~)
	}
	dwRet |= ubcp360_wCmdW( hDevID, X_AX, 0x0f4a );				// S~
	if(!dwRet)	*hDeviceID = hDevID;
	else		*hDeviceID = 0xffffffff;

	return dwRet;
}

//
// foCX̃N[Y
// 		FfoCXnh
//
DWORD hubcp364_DevClose(DWORD hDevID)
{
	DWORD	dwRet;

	dwRet = ubcp360_CloseDevice( hDevID );	// foCX̃N[Y
	return dwRet;
}

///////////////////////////////////////////////////////////////
//
//	ݒ̊֐
//
///////////////////////////////////////////////////////////////
//
// _A̐ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			F_A[h
//
DWORD hubcp364_SetOrgMode(DWORD hDevID, WORD axis, WORD mode)
{
	DWORD	dwRet;
	DWORD	dwData;

	// ԍ0`3ȊO܂
	// _A[h0`12ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM; 
	if((mode < 0) || (12 < mode))	return ILL_PRM;

	// WX^3(RENV3)Ǎ
	dwRet  = ubcp360_rReg( hDevID, axis, 0xde, &dwData );

	// Orgmode9̎CCTR2͂w߈ʒuɂ
	// (Orgmode9ȊO̎CCTR2͂͋@Bʒu)
	if( mode == 9 ) {
		dwData &= (DWORD)~0x00000300;
		dwData |= (DWORD) 0x00000100;
	}
	dwData &= (DWORD)~0x0000000f;
	dwData |= mode;

	// WX^3(RENV3)
	dwRet |= ubcp360_wReg( hDevID, axis, 0x9e, dwData );
	return dwRet;
}

//
// \tg~bg̐ݒ 
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			F+SLS
//			F-SLS
//			FSLSgp/sgp
//			F~@
//
DWORD hubcp364_SetSls( DWORD hDevID, WORD axis, long psls, long msls, WORD sel, WORD st )
{
	DWORD	dwRet;
	DWORD	dwEnv;

	// ԍ0`3ȊO
	// \tg~bggp+SLS < -SLS͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;
	if((sel) && (psls <= msls))		return ILL_PRM;

	// WX^4(RENV4)Ǎ
	dwRet = ubcp360_rReg(hDevID, axis, 0xdf, &dwEnv);
	if(!sel) {
	// SLSsgp
		dwEnv &= ~0x00001c1c;
	} else {
	// SLSgp
		// +SLSf[^ݒ
		dwRet |= ubcp360_wReg(hDevID, axis, 0xa7, psls);
		// -SLSf[^ݒ
		dwRet |= ubcp360_wReg(hDevID, axis, 0xa8, msls);

		dwEnv &= 0xffff0000;
		dwEnv |= 0x00001818;
		if(st)	dwEnv |= 0x00002020;
		else	dwEnv |= 0x00004040;
	}
	// WX^4(RENV4)
	dwRet |= ubcp360_wReg(hDevID, axis, 0x9f, dwEnv);
	return dwRet;
}

//
// ELS̐ݒ
//		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			Fɐ
//			F~@
//
DWORD hubcp364_SetEls( DWORD hDevID, WORD axis, WORD pol, WORD st )
{
	BYTE	byData;
	DWORD	dwRet;				// ߂l
	DWORD	dwData;

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;

	// ELSɐ|[gǍ
	dwRet = ubcp360_rPortB( hDevID, CP36_ELSPOL, &byData );

	if(pol) byData |= (BYTE) (0x01 << axis);	// A
	else 	byData &= (BYTE)~(0x01 << axis);	// B

	// ELSɐ|[g
	dwRet |= ubcp360_wPortB(hDevID, CP36_ELSPOL, byData);

	// WX^P(RENV1)Ǎ
	dwRet |= ubcp360_rReg(hDevID, axis, 0xdc, &dwData);

	if(st)	dwData |= (DWORD) 0x8;	// ~
	else	dwData &= (DWORD)~0x8;	// ~

	// WX^P(RENV1)
	dwRet |= ubcp360_wReg(hDevID, axis, 0x9c, dwData);
	return dwRet;
}

//
// OLS̐ݒ 
// 		F
//			FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			Fɐ
//
DWORD hubcp364_SetOls(DWORD hDevID, WORD axis, WORD pol)
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;

	// WX^P(RENV1)Ǎ
	dwRet = ubcp360_rReg(hDevID, axis, 0xdc, &dwData);
	if(pol) dwData |= (DWORD) 0x80;	// A
	else	dwData &= (DWORD)~0x80;	// B
	// WX^P(RENV1)
	dwRet |= ubcp360_wReg(hDevID, axis, 0x9c, dwData);
	return dwRet;
}

//
// SVALM̐ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			Fɐ
//			F~@
//
DWORD hubcp364_SetSvAlm( DWORD hDevID, WORD axis, WORD pol, WORD st )
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;

	// WX^P(RENV1)Ǎ
	dwRet = ubcp360_rReg(hDevID, axis, 0xdc, &dwData);
	if(pol) dwData |= (DWORD) 0x200;	// A
	else	dwData &= (DWORD)~0x200;	// B

	if(st)	dwData |= (DWORD) 0x0100;	// ~
	else	dwData &= (DWORD)~0x0100;	// ~

	// WX^P(RENV1)
	dwRet |= ubcp360_wReg(hDevID, axis, 0x9c, dwData);
	return dwRet;
}

//
// GR[_Z̐ݒ 
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			F_AŎgpy
//			Fɐ
//
DWORD hubcp364_SetEz(DWORD hDevID, WORD axis, WORD count, WORD pol)
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;

	// _AŎgpZ
	count &= 0x000f;

	// WX^3(RENV3)Ǎ
	dwRet = ubcp360_rReg(hDevID, axis, 0xde, &dwData);
	dwData &= 0xffffff0f;
	dwData |= count << 4;
	// WX^3(RENV3)
	dwRet |= ubcp360_wReg(hDevID, axis, 0x9e, dwData);	

	// ɐI
	// WX^Q(RENV2)Ǎ
	dwRet |= ubcp360_rReg(hDevID, axis, 0xdd, &dwData);

	if(pol) dwData |= (DWORD) 0x800000;	// 
	else	dwData &= (DWORD)~0x800000;	// オ

	// WX^2(RENV2)
	dwRet |= ubcp360_wReg(hDevID, axis, 0x9d, dwData);
	return dwRet;
}

//
// w߃pX̏o͌`̐ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			Fw߃pX̏o͌`(ʃpX/ʃpX)
//
DWORD hubcp364_SetCmdPulse(DWORD hDevID, WORD axis, WORD cmdpls)
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO ܂
	// w߃pX̏o͌`0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))		return ILL_PRM;
	if((cmdpls < 0) || (3 < cmdpls))	return ILL_PRM;

	// WX^P(RENV1)Ǎ
	dwRet = ubcp360_rReg(hDevID, axis, 0xdc, &dwData);
	dwData &= (DWORD)~0x7;
	switch(cmdpls) {
		case 0:	dwData |= (DWORD)0x04;	break;	// 
		case 1:	dwData |= (DWORD)0x02;	break;	// 
	}

	// WX^P(RENV1)
	dwRet |= ubcp360_wReg(hDevID, axis, 0x9c, dwData);
	return dwRet;
}

//
// `ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			F`(/S)
//
DWORD hubcp364_SetAccProfile(DWORD hDevID, WORD axis, WORD accpro)
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;

	// 샂[h(RMD)Ǎ
	dwRet = ubcp360_rReg(hDevID, axis, 0xd7, &dwData);

	if(accpro)	dwData |= (DWORD) 0x400;	// S
	else		dwData &= (DWORD)~0x400;	// 

	// 샂[h(PRMD)
	dwRet |= ubcp360_wReg(hDevID, axis, 0x87, dwData);
	return dwRet;
}

//
// _̐ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			F_̐ݒ(/}jA)
//
DWORD hubcp364_SetAutoDec(DWORD hDevID, WORD axis, WORD para)
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;

	// 샂[h(RMD)Ǎ
	dwRet = ubcp360_rReg(hDevID, axis, 0xd7, &dwData);
	if(para)	dwData |= (DWORD) 0x2000;	// }jA
	else		dwData &= (DWORD)~0x2000;	// 

	// 샂[h(PRMD)
	dwRet |= ubcp360_wReg(hDevID, axis, 0x87, dwData);
	return dwRet;
}

//
// ėp/}DR/PCS/DLS͑I, ݒ
//  FfoCXnh
//		F(0:X,1:Y,2:Z,3:U)
//		Fėp/}DR/PCS/DLS͑I
//		F͋ɐ
//		FDLŜ͎/~
//		FDLS͂b`/Ȃ
//
DWORD hubcp364_mSetDls( DWORD hDevID, WORD para, WORD pol, WORD stp, WORD ltc )
{
	DWORD	dwRet;
	DWORD	dwRmd[4];
	DWORD	dwRenv1[4];
	WORD	axis;
	WORD	wData[4];
	WORD	vDr[4] = { 0x100, 0x200, 0x400, 0x000 };
	WORD	vPc[4] = { 0x010, 0x020, 0x040, 0x080 };
	WORD	vDl[4] = { 0x001, 0x002, 0x004, 0x008 };
	BYTE	byData;

	// I
	for( axis = X_AX; axis < 4; axis++ ) {
		wData[axis] = ( para & ( 0x03 << axis * 2 ) ) >> ( axis * 2 ); 
	}

	if( wData[X_AX] == 1 ) {							// +XDRgpȂ
		if( wData[Y_AX] != 1 )		return ILL_PRM;		// -XDRłȂ΂ȂȂ
	} else {											// +XDRgpȂ
		if( wData[Y_AX] == 1 )		return ILL_PRM;		// -XDRgpɂȂĂ͂ȂȂ
	}
	if( wData[Z_AX] == 1 ) {							// +ZDRgpȂ
		if( wData[U_AX] != 1 )		return ILL_PRM;		// -ZDRłȂ΂ȂȂ
	} else {											// +ZDRgpȂ
		if( wData[U_AX] == 1 )		return ILL_PRM;		// -ZDRgpɂȂĂ͂ȂȂ
	}
	dwRet  = ubcp360_rPortB( hDevID, CP36_INT, &byData );
	if( byData & 0x40 ) {								// ~LȂ
		if( pol & vDr[Y_AX] )		return ILL_PRM;		// ~Ĺ}YDR͎gps
	}

	dwRet |= ubcp360_wPortB( hDevID, CP36_DLSSEL, (BYTE)para );		// ėp/}DR/PCS/DLS͑I|[g
	for( axis = X_AX; axis < 4; axis++ ) {
		dwRet |= ubcp360_rReg( hDevID, axis, 0xd7, &dwRmd[axis] );	// 샂[h(RMD)Ǐo
		dwRet |= ubcp360_rReg( hDevID, axis, 0xdc, &dwRenv1[axis] );	// WX^P(RENV1)Ǐo
		// YDRPCS,DLS,ėp͂ƓƗ
		if( pol & vDr[Y_AX] )	dwRenv1[Y_AX] |=  0x2000000;			// YDRA
		else					dwRenv1[Y_AX] &= ~0x2000000;			// YDRB
		if( wData[axis] == 0 ) {										// ėp
			dwRmd[axis] &= ~0x100;											// DLSsgp
			dwRenv1[axis] &= ~0x3000070;									// DLS,PCS,DR B
																			// DLŜ݁Cb`Ȃ
		}
		if( wData[axis] == 1 ) {										// DRgp
			dwRmd[axis] &= ~0x100;											// DLSsgp
			dwRenv1[axis] &= ~0x1000070;									// PCS,DLS B
																			// DLŜ݁Cb`Ȃ
			if( pol & vDr[X_AX] )	dwRenv1[X_AX] |=  0x2000000;			// XDRA
			else					dwRenv1[X_AX] &= ~0x2000000;			// XDRB
			if( pol & vDr[Z_AX] )	dwRenv1[Z_AX] |=  0x2000000;			// ZDRA
			else					dwRenv1[Z_AX] &= ~0x2000000;			// ZDRB
		}
		if( wData[axis] == 2 ) {										// PCSgp
			dwRmd[axis] &= ~0x100;											// DLSsgp
			dwRenv1[axis] &= ~0x2000070;									// DLS,DR B
																			// DLŜ݁Cb`Ȃ
			if( pol & vPc[axis] )	dwRenv1[axis] |=  0x1000000;			// PCSA
			else					dwRenv1[axis] &= ~0x1000000;			// PCSB
		}
		if( wData[axis] == 3 ) {										// DLSgp
			dwRmd[axis] |= 0x100;											// DLSgp
			dwRenv1[axis] &= ~0x3000000;									// PCS,DR B
			if( pol & vDl[axis] )	dwRenv1[axis] |=  0x40;					// DLSA
			else					dwRenv1[axis] &= ~0x40;					// DLSB
			if( stp & vDl[axis] )	dwRenv1[axis] |=  0x10;					// DLS͌~
			else					dwRenv1[axis] &= ~0x10;					// DLS͌̂
			if( ltc & vDl[axis] )	dwRenv1[axis] |=  0x20;					// DLSb`
			else					dwRenv1[axis] &= ~0x20;					// DLSb`Ȃ
		}
		dwRet |= ubcp360_wReg( hDevID, axis, 0x87,  dwRmd[axis] );		// 샂[h(PRMD)
		dwRet |= ubcp360_wReg( hDevID, axis, 0x9c,  dwRenv1[axis] );	// WX^P(RENV1)
	}
	return dwRet;
}

//
// ėp(SVRDY)/LATCH͑I, ݒ
//  FfoCXnh
//		F(0:X,1:Y,2:Z,3:U)
//		Fėp(SVRDY)/LATCH͑I
//		FLATCH͋ɐ
//
DWORD hubcp364_mSetLtc( DWORD hDevID, WORD axis, WORD para, WORD pol )
{
	DWORD	dwRet, dwRenv1;
	WORD	wData;

	dwRet  = ubcp360_rPortW( hDevID, CP36_LTCSEL, &wData );	// ėp/LATCH͑I|[gǏo
	dwRet |= ubcp360_rReg( hDevID, axis, 0xdc, &dwRenv1 );	// WX^P(RENV1)Ǐo
	if( para == 0 ) {										// ėp͑I
		wData &= ~( 0x0010 << axis );						// ėp͐ݒ
		dwRenv1 |= (DWORD)0x800000;							// A
	} else {												// ėp͑I
		wData |=  ( 0x0010 << axis );						// LATCH͐ݒ
		if( pol )	dwRenv1 |= (DWORD) 0x800000;			// A
		else		dwRenv1 &= (DWORD)~0x800000;			// B
	}
	dwRet |= ubcp360_wPortW( hDevID, CP36_LTCSEL, wData );	// ėp/LATCH͑I|[g
	dwRet |= ubcp360_wReg( hDevID, axis, 0x9c,  dwRenv1 );	// WX^P(RENV1)
	return dwRet;
}

//
// INPOS/ėp͑I, ݒ
//  FfoCXnh
//		F(0:X,1:Y,2:Z,3:U)
//		FINPOS/ėp͑I(INPOS͑IINPOSL)
//		FINPOSɐݒ
//
DWORD hubcp364_mSetInpos( DWORD hDevID, WORD axis, WORD para, WORD pol )
{
	DWORD	dwRet, dwRmd, dwRenv1;
	WORD	wData;

	dwRet  = ubcp360_rPortW( hDevID, CP36_LTCSEL, &wData );	// INPOS/ėp͑I|[gǏo
	dwRet |= ubcp360_rReg( hDevID, axis, 0xd7, &dwRmd );	// 샂[h(RMD)Ǐo
	dwRet |= ubcp360_rReg( hDevID, axis, 0xdc, &dwRenv1 );	// WX^P(RENV1)Ǐo
	if( para == 0 ) {										// INPOS͑I
		wData &= ~( 0x0001 << axis );						// ėp͐ݒ
		dwRmd |= (DWORD) 0x0200;							// INPOSgp
		if( pol )	dwRenv1 |= (DWORD) 0x400000;			// A
		else		dwRenv1 &= (DWORD)~0x400000;			// B
	} else {												// ėp͑I
		wData   |=  ( 0x0001 << axis );						// ėp͐ݒ
		dwRmd   &= (DWORD)~0x000200;						// INPOSsgp
		dwRenv1 &= (DWORD)~0x400000;						// B
	}
	dwRet |= ubcp360_wPortW( hDevID, CP36_LTCSEL, wData );	// INPOS/ėp͑I|[g
	dwRet |= ubcp360_wReg( hDevID, axis, 0x87,  dwRmd );	// 샂[h(PRMD)
	dwRet |= ubcp360_wReg( hDevID, axis, 0x9c,  dwRenv1 );	// WX^P(RENV1)
	return dwRet;
}

//
// SVCTRCLo/ėpo͑I, ݒ
//  FfoCXnh
//		F(0:X,1:Y,2:Z,3:U)
//		FSVCTRCL/ėpo͑I
//		FSVCTRCLo͐ݒ
//
DWORD hubcp364_mSetSvCtrCl( DWORD hDevID, WORD axis, WORD pala, WORD enable )
{
	DWORD	dwRet, dwData;
	WORD	dt;

	dwRet = ubcp360_rPortW( hDevID, CP36_CLRSEL, &dt );		// SVCTRCLo/ėpo͑I|[gǏo
	if( pala == 0 ) {										// SVCTRCLo͑I
		dt &= ~( 0x0001 << axis );							// SVCTRCLo͐ݒ
		dwRet |= ubcp360_rReg( hDevID, axis, 0xdc, &dwData );	// WX^P(RENV1)Ǐo
		dwData &= (DWORD)~0x0c00;							// SVCTRCL̏o͐ݒrbgOɂ
		switch( enable ) {
			case 0:								break;		// sgp
			case 1:	dwData |= (DWORD) 0x0800;	break;		// _A
			case 2:	dwData |= (DWORD) 0x0400;	break;		// ُ~
			case 3:	dwData |= (DWORD) 0x0c00;	break;		// _Ayшُ~
		}
		dwRet |= ubcp360_wReg( hDevID, axis, 0x9c,  dwData );	// WX^P(RENV1)
	} else {												// ėpo͑I
		dt |=  ( 0x0001 << axis );							// ėpo͐ݒ
	}
	dwRet |= ubcp360_wPortW( hDevID, CP36_CLRSEL,  dt );		// SVCTRCLo/ėpo͑I|[g

	return dwRet;
}


///////////////////////////////////////////////////////////////
//
//	Ǎ݌n̊֐	
//
///////////////////////////////////////////////////////////////
//
// CXe[^XǍ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			FCXe[^X
//
DWORD hubcp364_ReadMainSts(DWORD hDevID, WORD axis, WORD* msts)
{
	WORD	wData;
	DWORD	dwRet;				// ߂l

	*msts = 0;

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;

	// CXe[^XǍ
	dwRet = ubcp360_rMstsW(hDevID, axis, &wData);
	if(dwRet)	*msts = 0;
	else		*msts = wData;
	return dwRet;
}

//
// G[Xe[^XǍ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			FG[Xe[^X
//
DWORD hubcp364_ReadErrorSts(DWORD hDevID, WORD axis, DWORD* ests)
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	*ests = 0;

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;

	// G[Xe[^XǍ
	dwRet = ubcp360_rReg(hDevID, axis, 0xf2, &dwData);
	if(dwRet)	*ests = 0;
	else		*ests = dwData;
	return dwRet;
}

//
// CxgXe[^XǍ 
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			FCxgXe[^X
//
DWORD hubcp364_ReadEventSts(DWORD hDevID, WORD axis, DWORD* ists)
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	*ists = 0;

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;

	// CxgXe[^XǍ
	dwRet = ubcp360_rReg(hDevID, axis, 0xf3, &dwData);
	if(dwRet)	*ists = 0;
	else		*ists = dwData;
	return dwRet;
}

//
// TuXe[^XǍ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			FTuXe[^X
//
DWORD hubcp364_ReadSubSts(DWORD hDevID, WORD axis, WORD* ssts)
{
	WORD	wData;
	DWORD	dwRet;				// ߂l

	*ssts = 0;
	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;

	// TuXe[^XǍ
	dwRet = ubcp360_rSstsW(hDevID, axis, &wData);
	if(dwRet)	*ssts = 0;
	else		*ssts = wData;
	return dwRet;
}

//
// gXe[^XǍ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			FgXe[^X
//
DWORD hubcp364_ReadExSts(DWORD hDevID, WORD axis, DWORD* exsts)
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	*exsts = 0;

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;

	// gXe[^XǍ
	dwRet = ubcp360_rReg(hDevID, axis, 0xf1, &dwData);
	if(dwRet)	*exsts = 0;
	else		*exsts = dwData;
	return dwRet;
}

//
// ԃXe[^XǍ
// 		FfoCXnh
//			FԃXe[^X
//
DWORD hubcp364_ReadIpSts(DWORD hDevID, DWORD* ipsts)
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	*ipsts = 0;

	// ԃXe[^XǍ
	dwRet = ubcp360_rReg(hDevID, 0, 0xff, &dwData);
	if(dwRet)	*ipsts = 0;
	else		*ipsts = dwData;
	return dwRet;
}

//
// xǍ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			FxWX^l(RSPD)
//		wߑx(pps) = RSPD * {
//
DWORD hubcp364_ReadSpd(DWORD hDevID, WORD axis, WORD* spd)
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	*spd = 0;

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;

	// xǍ
	dwRet = ubcp360_rReg(hDevID, axis, 0xf5, &dwData);
	if(dwRet) {
		*spd = 0;
	} else {
		dwData &= (DWORD)0x0000ffff;
		*spd = (WORD)dwData;
	}
	return dwRet;
}

//
// JE^Ǎ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			FǍJE^(1:CTR1, 2:CTR2, 3:CTR3, 4:CTR4)
//			FJE^l
//
DWORD hubcp364_ReadCtr(DWORD hDevID, WORD axis, WORD sel, long* count)
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	*count = 0;

	// ԍ0`3ȊO܂
	// ǍJE^1`4ȊO͈̎G[
	if((axis < 0) || (3 < axis))		return ILL_PRM;
	if((sel  < 1) || (4 < sel))			return ILL_PRM;

	// JE^Ǎ
	dwRet = ubcp360_rReg(hDevID, axis, (BYTE)(0xe2 + sel), &dwData);
	if( dwRet )	*count = 0;
	else		*count = dwData;
	return dwRet;
}

//
// b`f[^Ǎ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			FǍJE^(1:CTR1, 2:CTR2, 3:CTR3, 4:CTR4)
//			FJE^l
//
DWORD hubcp364_ReadLtc(DWORD hDevID, WORD axis, WORD sel, long* latch)
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	*latch = 0;

	// ԍ0`3ȊO܂
	// ǍJE^1`4ȊO͈̎G[
	if((axis < 0) || (3 < axis))		return ILL_PRM;
	if((sel  < 1) || (4 < sel))			return ILL_PRM;

	// JE^Ǎ
	dwRet = ubcp360_rReg(hDevID, axis, (BYTE)(0xec + sel), &dwData);
	if( dwRet )	*latch = 0;
	else		*latch = dwData;
	return dwRet;
}

///////////////////////////////////////////////////////////////
//
//	ݒn̊֐
//
///////////////////////////////////////////////////////////////
//
// Cxg}XN̐ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			FCxg}XNf[^
//
DWORD hubcp364_SetEventMask(DWORD hDevID, WORD axis, DWORD mask)
{
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO܂
	// Cxg}XNf[^ 0`0x0003ffffȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;
	if(mask & 0xfffc0000)			return ILL_PRM;

	// Cxg}XN(RIRQ)WX^̏
	dwRet = ubcp360_wReg(hDevID, axis, 0xac, mask);
	return dwRet;
}

//
// x[Xx̐ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			Fx[XxWX^
//
DWORD hubcp364_SetFLSpd(DWORD hDevID, WORD axis, DWORD spd)
{
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO܂
	// xWX^1`0xffffȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;
	if((!spd) || (0xffff < spd))	return ILL_PRM;

	// PRFL̏
	dwRet = ubcp360_wReg(hDevID, axis, 0x81, spd);
	return dwRet;
}

//
// ⏕x̐ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			F⏕xWX^
//
DWORD hubcp364_SetAuxSpd(DWORD hDevID, WORD axis, DWORD spd)
{
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO܂
	// xWX^1`0xffffȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;
	if((!spd) || (0xffff < spd))	return ILL_PRM;

	// RFȀ
	dwRet = ubcp360_wReg(hDevID, axis, 0x9b, spd);
	return dwRet;
}

//
// [g̐ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			F[g
// 			NbNg = 19660800Hz
// 			(b) = (PRFH - PRFL) * (PRUR + 1) * 4 / 19660800
// 			r(b) = (PRFH - PRFL) * (PRUR + 1) * 8 / 19660800
//
DWORD hubcp364_SetAccRate(DWORD hDevID, WORD axis, DWORD rate)
{
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO܂
	// [g1`0xffffȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;
	if((!rate) || (0xffff < rate))	return ILL_PRM;

	// PRUȐ
	dwRet = ubcp360_wReg(hDevID, axis, 0x83, rate);
	return dwRet;
}

//
// [g̐ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			F[g
// 			NbNg = 19660800Hz
// 			(b) = (PRFH - PRFL) * (PRUR + 1) * 4 / 19660800
// 			r(b) = (PRFH - PRFL) * (PRUR + 1) * 8 / 19660800
//
DWORD hubcp364_SetDecRate(DWORD hDevID, WORD axis, DWORD rate)
{
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;
	if(0xffff < rate)				return ILL_PRM;

	// PRDȐ
	dwRet = ubcp360_wReg(hDevID, axis, 0x84, rate);
	return dwRet;
}

//
// {ݒl(RMG)̐ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			F{ݒl(RMG)
// 			RMG = 300 / { - 1
//
DWORD hubcp364_SetMult(DWORD hDevID, WORD axis, DWORD rmg)
{
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO܂
	// {ݒl1ȉ͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;
	if(rmg < 2)						return ILL_PRM;

	// PRMG̏
	dwRet = ubcp360_wReg(hDevID, axis, 0x85, rmg);
	return dwRet;
}

//
// _̐ݒ
//	_vZ̓ItZbgl
//	_蓮vZ͎cړʂ_ݒpXȉŌJn 
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			F_(pulse)
//
DWORD hubcp364_SetDecPoint(DWORD hDevID, WORD axis, long dstnc)
{
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;

	// PRDP̏
	dwRet = ubcp360_wReg(hDevID, axis, 0x86, dstnc);
	return dwRet;
}

///////////////////////////////////////////////////////////////
//
//	^pݒn̊֐
//
///////////////////////////////////////////////////////////////
//
// 샂[h
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			F샂[h
//
DWORD hubcp364_WritOpeMode( DWORD hDevID, WORD axis, WORD mode )
{
	DWORD	dwData;
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO܂
	// 샂[hُ͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;
	if(mode & 0xff80)				return ILL_PRM;
	if(!mod_tbl[mode])				return ILL_PRM;

	// 샂[h(RMD)Ǎ
	dwRet = ubcp360_rReg(hDevID, axis, 0xd7, &dwData);
	dwData &= ~0x00000000ff;
	if(mode == 0x42) {		// PCSʒu
		dwData |=  0x4041;
	} else {
		dwData &= ~0x4000;	// PCSʒu߈ȊO̓샂[h
		dwData |=  mode;
	}

	// 샂[h(PRMD)
	dwRet |= ubcp360_wReg(hDevID, axis, 0x87, dwData);
	return dwRet;
}

//
// 쑬xWX^̐ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			F쑬xWX^(PRFH)
//	wߑx(pps) = PRFH * {
//
DWORD hubcp364_WritFHSpd( DWORD hDevID, WORD axis, DWORD spd )
{
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO܂
	// xWX^1`0xffffȊO͈̎G[
	if((axis < 0) || (3 < axis))	return ILL_PRM;
	if((!spd) || (spd > 0xffff))	return ILL_PRM;

	// PRFH̏
	dwRet = ubcp360_wReg( hDevID, axis, 0x82, spd );
	return dwRet;
}

//
// ʒu߈ړʂ̐ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			Fړ(pulse)
//
DWORD hubcp364_WritPos(DWORD hDevID, WORD axis, long dstnc)
{
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))					return ILL_PRM;

	// ړʂ̃`FbN
	if((dstnc < -134217728) || (134217727 < dstnc))	return ILL_PRM;

	// PRMV̏
	dwRet = ubcp360_wReg( hDevID, axis, 0x80, dstnc );
	return dwRet;
}

//
// Ԃ̈ړʂ̐ݒ
// 		FfoCXnh
//			F(0:X,1:Y,2:Z,3:U)
//			Fړ(pulse)
//
DWORD hubcp364_WritLine( DWORD hDevID, WORD axis, long dstnc )
{
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO͈̎G[
	if((axis < 0) || (3 < axis))					return ILL_PRM;

	// ړʂ̃`FbN
	if((dstnc < -134217728) || (134217727 < dstnc))	return ILL_PRM;

	// PRMV̏
	dwRet = ubcp360_wReg( hDevID, axis, 0x80, dstnc );
	return dwRet;
}

//
// ~ʕԂ̃f[^ݒ
// 		FfoCXnh
//			Fgݍ킹
//			FI_ʒu1
//			FI_ʒu2
//			FSʒu1
//			FSʒu2
//
DWORD hubcp364_WritCircl(DWORD hDevID, WORD axis,
						long dstnc1, long dstnc2, long center1,long center2)
{
	DWORD	dwRet; 				// ߂l
	WORD	ax1,ax2;

	// Ԏ̑gݍ킹̈0`5ȊO̎̓G[
	if((axis < 0) || (axis > 5))	return ILL_PRM;
	if((dstnc1 < -134217728)  || (134217727 < dstnc1))	return ILL_PRM;
	if((dstnc2 < -134217728)  || (134217727 < dstnc2))	return ILL_PRM;
	if((center1 < -134217728) || (134217727 < center1))	return ILL_PRM;
	if((center2 < -134217728) || (134217727 < center2))	return ILL_PRM;

	switch(axis) {
		case  0:	ax1 = 0;	ax2 = 1;	break;	// X(0), Y(1)
		case  1:	ax1 = 0;	ax2 = 2;	break;	// X(0), Z(2)
		case  2:	ax1 = 0;	ax2 = 3;	break;	// X(0), U(3)
		case  3:	ax1 = 1;	ax2 = 2;	break;	// Y(1), Z(2)
		case  4:	ax1 = 1;	ax2 = 3;	break;	// Y(1), U(3)
		case  5:	ax1 = 2;	ax2 = 3;	break;	// Z(2), U(3)
	}
	// PRMV(I_ʒu)̏
	dwRet  = ubcp360_wReg(hDevID, ax1, 0x80, dstnc1);
	dwRet |= ubcp360_wReg(hDevID, ax2, 0x80, dstnc2);	// Y,Z,U,Z,U,U
	// PRIP(Sʒu)̏
	dwRet |= ubcp360_wReg(hDevID, ax1, 0x88, center1);
	dwRet |= ubcp360_wReg(hDevID, ax2, 0x88, center2);	// Y,Z,U,Z,U,U
	return dwRet;
}

//
// JE^vZbg
// 		FfoCXnh
//			F
//			FvZbgl
//			FJE^I
//
DWORD hubcp364_WritCtr(DWORD hDevID, WORD axis, long preset, WORD sel)
{
	BYTE	byCmd;
	DWORD	dwRet;				// ߂l

	// ԍ0`3ȊO܂̓JE^1`4ȊO̎̓G[
	if((axis < 0) || (3 < axis))						return ILL_PRM;
	if((sel < 1) || (4 < sel))							return ILL_PRM;
	// vZbgl̃`FbN
	if((preset < -134217728) || (134217727 < preset))	return ILL_PRM;

	// vZbgl
	byCmd = (BYTE)(0xa2 + sel);	// JE^I
	dwRet = ubcp360_wReg(hDevID, axis, byCmd, preset);
	return dwRet;
}

/////////////////////////////////////////////////////////////
//
//	쐧n̊֐
//
/////////////////////////////////////////////////////////////
//
// ~
// 		FfoCXnh
//			Fgݍ킹(HEX)
//
DWORD hubcp364_DecStop(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				// ߂l

	// ԍ0x01`0x0fȊO̎̓G[
	if((!axis) || (axis & ~0xf))		return ILL_PRM;

	// wɌ~
	dwRet = ubcp360_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x4a));
	return dwRet;
}

//
// ~
// 		FfoCXnh
//			Fgݍ킹(HEX)
//
DWORD hubcp364_QuickStop(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				// ߂l

	// ԍ0x01`0x0fȊO̎̓G[
	if((!axis) || (axis & ~0xf))		return ILL_PRM;

	// wɑ~
	dwRet = ubcp360_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x49));
	return dwRet;
}

//
// ~
// 		FfoCXnh
//			Fgݍ킹(HEX)
//
DWORD hubcp364_EmgStop(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				// ߂l

	// ԍ0x01`0x0fȊO̎̓G[
	if((!axis) || (axis & ~0xf))		return ILL_PRM;

	// wɔ~
	dwRet = ubcp360_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x05));
	return dwRet;
}

//
// X^[g
// 		FfoCXnh
//			Fgݍ킹(HEX)
//
DWORD hubcp364_AccStart(DWORD hDevID, WORD axis)
{
	WORD	wCmd;
	DWORD	dwRet;				// ߂l

	// ԍ0x01`0x0fȊO̎̓G[
	if((!axis) || (axis & ~0xf))		return ILL_PRM;

 	wCmd = (axis << 8) | 0x53;
	dwRet = ubcp360_wCmdW(hDevID, 0, wCmd);		// R}h
	
	return dwRet;
}

//
// FH葬X^[g
// 		FfoCXnh
//			Fgݍ킹(HEX)
//
DWORD hubcp364_CnstStartFH(DWORD hDevID, WORD axis)
{
	WORD	wCmd;
	DWORD	dwRet;				// ߂l

	// ԍ0x01`0x0fȊO̎̓G[
	if((!axis) || (axis & ~0xf))		return ILL_PRM;

 	wCmd = (axis << 8) | 0x51;
	dwRet = ubcp360_wCmdW(hDevID, 0, wCmd);		// R}h

	return dwRet;
}

//
// FL葬X^[g
// 		FfoCXnh
//			Fgݍ킹(HEX)
//
DWORD hubcp364_CnstStartFL(DWORD hDevID, WORD axis)
{
	WORD	wCmd;
	DWORD	dwRet;				// ߂l

	// ԍ0x01`0x0fȊO̎̓G[
	if((!axis) || (axis & ~0xf))		return ILL_PRM;

 	wCmd = (axis << 8) | 0x50;
	dwRet = ubcp360_wCmdW(hDevID, 0, wCmd);		// R}h

	return dwRet;
}

//
// FH葬X^[g㌸~ 
// 		FfoCXnh
//			Fgݍ킹(HEX)
//
DWORD hubcp364_ConstStartByDec(DWORD hDevID, WORD axis)
{
	WORD	wCmd;
	DWORD	dwRet;				// ߂l

	// ԍ0x01`0x0fȊO̎̓G[
	if((!axis) || (axis & ~0xf))		return ILL_PRM;

 	wCmd = (axis << 8) | 0x52;
	dwRet = ubcp360_wCmdW(hDevID, 0, wCmd);		// R}h

	return dwRet;
}

//
// T[{I
// 		FfoCXnh
//			Fgݍ킹(HEX)
//
DWORD hubcp364_SvOn(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				// ߂l

	// ԍ0x01`0x0fȊO̎̓G[
	if((!axis) || (axis & ~0xf))		return ILL_PRM;

	// wɃT[{nm
	dwRet = ubcp360_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x18));
	return dwRet;
}

//
// T[{It
// 		FfoCXnh
//			Fgݍ킹(HEX)
//
DWORD hubcp364_SvOff(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				// ߂l

	// ԍ0x01`0x0fȊO̎̓G[
	if((!axis) || (axis & ~0xf))		return ILL_PRM;

	// wɃT[{nee
	dwRet = ubcp360_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x10));
	return dwRet;
}

//
// T[{ZbgI
// 		FfoCXnh
//			Fgݍ킹(HEX)
//
DWORD hubcp364_SvResetOn(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				// ߂l

	// ԍ0x01`0x0fȊO̎̓G[
	if((!axis) || (axis & ~0xf))		return ILL_PRM;

	// wɃT[{Zbgnm
	dwRet = ubcp360_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x19));
	return dwRet;
}

//
// T[{ZbgIt
// 		FfoCXnh
//			Fgݍ킹(HEX)
//
DWORD hubcp364_SvResetOff(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				// ߂l

	// ԍ0x01`0x0fȊO̎̓G[
	if((!axis) || (axis & ~0xf))		return ILL_PRM;

	// wɃT[{Zbgnee
	dwRet = ubcp360_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x11));
	return dwRet;
}

//
// pX[^I
// 		FfoCXnh
//			Fgݍ킹(HEX)
//
DWORD hubcp364_PMOn(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				// ߂l

	// ԍ0x01`0x0fȊO̎̓G[
	if((!axis) || (axis & ~0xf))		return ILL_PRM;

	// wɃpX[^nm
	dwRet = ubcp360_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x10));
	return dwRet;
}

//
// pX[^It 
// 		FfoCXnh
//			Fgݍ킹(HEX)
//
DWORD hubcp364_PMOff(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				// ߂l

	// ԍ0x01`0x0fȊO̎̓G[
	if((!axis) || (axis & ~0xf))		return ILL_PRM;

	// wɃpX[^nee
	dwRet = ubcp360_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x18));
	return dwRet;
}

//
// ėp͏ԓǏo
//	FfoCXnh
//		Fėp͓_ԍ
//		F͏
//
DWORD hubcp364_ReadInNo ( DWORD hDevID, WORD inno, WORD* data )
{
	DWORD	dwRet = 0;
	WORD	prt;

	*data = 0;

	if( inno < 17 ) {
		dwRet = ubcp360_rPortW( hDevID, CP36_INP1, &prt );
		if( prt & ( 0x0001 << ( inno - 1 ) ) ) {
			*data = 1;
		} else {
			*data = 0;
		}
	} else if( inno == 17 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_LTCSEL, &prt );
		if( prt & 1 ) {										// ėp17
			dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
			if( prt & 1 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		} else {											// XINPOS͑I̓G[
			dwRet = ILL_PRM;
		}
	} else if( inno == 18 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_LTCSEL, &prt );
		if( prt & 0x10 ) {									// XLATCH͑I̓G[
			dwRet = ILL_PRM;
		} else {											// ėp18(XSVRDY)
			dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
			if( prt & 2 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		}
	} else if( inno == 19 ) {								
		dwRet  = ubcp360_rPortW( hDevID, CP36_LTCSEL, &prt );
		if( prt & 2 ) {										// ėp19
			dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
			if( prt & 4 ) {									
				*data = 1;
			} else {
				*data = 0;
			}
		} else {
			dwRet = ILL_PRM;								// YINPOS͑I̓G[
		}
	} else if( inno == 20 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_LTCSEL, &prt );
		if( prt & 0x20 ) {									// YLATCH͑I̓G[
			dwRet = ILL_PRM;
		} else {											// ėp20(YSVRDY)
			dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
			if( prt & 8 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		}
	} else if( inno == 21 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_LTCSEL, &prt );
		if( prt & 4 ) {										// ėp21
			dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
			if( prt & 0x10 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		} else {											// ZINPOS͑I̓G[
			dwRet = ILL_PRM;
		}
	} else if( inno == 22 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_LTCSEL, &prt );
		if( prt & 0x40 ) {									// ZLATCH͑I̓G[
			dwRet = ILL_PRM;
		} else {											// ėp22(ZSVRDY)
			dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
			if( prt & 0x20 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		}
	} else if( inno == 23 ) {								
		dwRet  = ubcp360_rPortW( hDevID, CP36_LTCSEL, &prt );
		if( prt & 8 ) {										// ėp23
			dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
			if( prt & 0x40 ) {									
				*data = 1;
			} else {
				*data = 0;
			}
		} else {
			dwRet = ILL_PRM;								// ZINPOS͑I̓G[
		}
	} else if( inno == 24 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_LTCSEL, &prt );
		if( prt & 0x80 ) {									// ULATCH͑I̓G[
			dwRet = ILL_PRM;
		} else {											// ėp24(USVRDY)
			dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
			if( prt & 0x80 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		}	
	} else if( inno == 25 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_DLSSEL, &prt );
		if( prt & 3 ) {										// ėp25ȊOI̓G[
			dwRet = ILL_PRM;
		} else {											// ėp25
			dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
			if( prt & 0x100 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		}	
	} else if( inno == 26 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_DLSSEL, &prt );
		if( prt & 0xc ) {									// ėp26ȊOI̓G[
			dwRet = ILL_PRM;
		} else {											// ėp26
			dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
			if( prt & 0x200 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		}	
	} else if( inno == 27 ) {
		dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
		if( prt & 0x400 ) {
			*data = 1;
		} else {
			*data = 0;
		}
	} else if( inno == 28 ) {
		dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
		if( prt & 0x800 ) {
			*data = 1;
		} else {
			*data = 0;
		}
	} else if( inno == 29 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_DLSSEL, &prt );
		if( prt & 0x30 ) {									// ėp29ȊOI̓G[
			dwRet = ILL_PRM;
		} else {											// ėp29
			dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
			if( prt & 0x1000 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		}	
	} else if( inno == 30 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_DLSSEL, &prt );
		if( prt & 0xc0 ) {									// ėp30ȊOI̓G[
			dwRet = ILL_PRM;
		} else {											// ėp30
			dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
			if( prt & 0x2000 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		}	
	} else if( inno < 31 ) {
		dwRet = ubcp360_rPortW( hDevID, CP36_INP2, &prt );
		if( prt & ( 0x0001 << ( inno - 17 ) ) ) {
			*data = 1;
		} else {
			*data = 0;
		}
	} else {
		dwRet = ILL_PRM;
	}

	return dwRet;
}

//
// ėpo͏ԓǏo
//	FfoCXnh
//		Fėpo͓_ԍ
//		Fo͏
//
DWORD hubcp364_ReadOutNo( DWORD hDevID, WORD outno, WORD* data )
{
	DWORD	dwRet = 0;
	WORD	prt;

	*data = 0;

	if( outno < 17 ) {
		dwRet = ubcp360_rPortW( hDevID, CP36_OUTP1, &prt );
		if( prt & ( 0x0001 << ( outno - 1 ) ) ) {
			*data = 1;
		} else {
			*data = 0;
		}
	} else if( outno == 17 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_CLRSEL, &prt );
		if( prt & 1 ) {
			dwRet = ubcp360_rPortW( hDevID, CP36_OUTP2, &prt );
			if( prt & 1 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		} else {
			dwRet = ILL_PRM;
		}
	} else if( outno == 18 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_CLRSEL, &prt );
		if( prt & 2 ) {
			dwRet = ubcp360_rPortW( hDevID, CP36_OUTP2, &prt );
			if( prt & 2 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		} else {
			dwRet = ILL_PRM;
		}
	} else if( outno == 19 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_CLRSEL, &prt );
		if( prt & 4 ) {
			dwRet = ubcp360_rPortW( hDevID, CP36_OUTP2, &prt );
			if( prt & 4 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		} else {
			dwRet = ILL_PRM;
		}
	} else if( outno == 20 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_CLRSEL, &prt );
		if( prt & 8 ) {
			dwRet = ubcp360_rPortW( hDevID, CP36_OUTP2, &prt );
			if( prt & 8 ) {
				*data = 1;
			} else {
				*data = 0;
			}
		} else {
			dwRet = ILL_PRM;
		}
	} else if( outno == 21 ) {
		dwRet = ubcp360_rSstsW( hDevID, 0, &prt );
		*data = prt & 1;
	} else if( outno == 22 ) {
		dwRet = ubcp360_rSstsW( hDevID, 0, &prt );
		*data = ( prt & 2 ) >> 1;
	} else if( outno == 23 ) {
		dwRet = ubcp360_rSstsW( hDevID, 1, &prt );
		*data = prt & 1;
	} else if( outno == 24 ) {
		dwRet = ubcp360_rSstsW( hDevID, 1, &prt );
		*data = ( prt & 2 ) >> 1;
	} else if( outno == 25 ) {
		dwRet = ubcp360_rSstsW( hDevID, 2, &prt );
		*data = prt & 1;
	} else if( outno == 26 ) {
		dwRet = ubcp360_rSstsW( hDevID, 2, &prt );
		*data = ( prt & 2 ) >> 1;
	} else if( outno == 27 ) {
		dwRet = ubcp360_rSstsW( hDevID, 3, &prt );
		*data = prt & 1;
	} else if( outno == 28 ) {
		dwRet = ubcp360_rSstsW( hDevID, 3, &prt );
		*data = ( prt & 2 ) >> 1;
	} else {
		dwRet = ILL_PRM;
	}

	return dwRet;
}

//
// ėpo͐
//	FfoCXnh
//		Fėpo͓_ԍ
//		Fo͓_
//
DWORD hubcp364_WritOutNo( DWORD hDevID, WORD outno, WORD data )
{
	DWORD	dwRet;
	WORD	prt;

	data &= 1;

	if( outno < 17 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_OUTP1, &prt );
		if( data ) {
			prt |=  ( 0x0001 << ( outno - 1 ) );
		} else {
			prt &= ~( 0x0001 << ( outno - 1 ) );
		}
		dwRet |= ubcp360_wPortW( hDevID, CP36_OUTP1,  prt );
	} else if( outno == 17 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_CLRSEL, &prt );
		if( prt & 1 ) {
			dwRet  = ubcp360_rPortW( hDevID, CP36_OUTP2, &prt );
			if( data )	prt |=  0x0001;
			else		prt &= ~0x0001;
			dwRet |= ubcp360_wPortW( hDevID, CP36_OUTP2,  prt );
		} else {
			dwRet = ILL_PRM;
		}
	} else if( outno == 18 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_CLRSEL, &prt );
		if( prt & 2 ) {
			dwRet  = ubcp360_rPortW( hDevID, CP36_OUTP2, &prt );
			if( data )	prt |=  0x0002;
			else		prt &= ~0x0002;
			dwRet |= ubcp360_wPortW( hDevID, CP36_OUTP2,  prt );
		} else {
			dwRet = ILL_PRM;
		}
	} else if( outno == 19 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_CLRSEL, &prt );
		if( prt & 4 ) {
			dwRet  = ubcp360_rPortW( hDevID, CP36_OUTP2, &prt );
			if( data )	prt |=  0x0004;
			else		prt &= ~0x0004;
			dwRet |= ubcp360_wPortW( hDevID, CP36_OUTP2,  prt );
		} else {
			dwRet = ILL_PRM;
		}
	} else if( outno == 20 ) {
		dwRet  = ubcp360_rPortW( hDevID, CP36_CLRSEL, &prt );
		if( prt & 8 ) {
			dwRet  = ubcp360_rPortW( hDevID, CP36_OUTP2, &prt );
			if( data )	prt |=  0x0008;
			else		prt &= ~0x0008;
			dwRet |= ubcp360_wPortW( hDevID, CP36_OUTP2,  prt );
		} else {
			dwRet = ILL_PRM;
		}
	} else if( outno == 21 ) {
		if( data )	dwRet = ubcp360_wCmdW( hDevID, 0, 0x18 );
		else		dwRet = ubcp360_wCmdW( hDevID, 0, 0x10 );
	} else if( outno == 22 ) {
		if( data )	dwRet = ubcp360_wCmdW( hDevID, 0, 0x19 );
		else		dwRet = ubcp360_wCmdW( hDevID, 0, 0x11 );
	} else if( outno == 23 ) {
		if( data )	dwRet = ubcp360_wCmdW( hDevID, 1, 0x18 );
		else		dwRet = ubcp360_wCmdW( hDevID, 1, 0x10 );
	} else if( outno == 24 ) {
		if( data )	dwRet = ubcp360_wCmdW( hDevID, 1, 0x19 );
		else		dwRet = ubcp360_wCmdW( hDevID, 1, 0x11 );
	} else if( outno == 25 ) {
		if( data )	dwRet = ubcp360_wCmdW( hDevID, 2, 0x18 );
		else		dwRet = ubcp360_wCmdW( hDevID, 2, 0x10 );
	} else if( outno == 26 ) {
		if( data )	dwRet = ubcp360_wCmdW( hDevID, 2, 0x19 );
		else		dwRet = ubcp360_wCmdW( hDevID, 2, 0x11 );
	} else if( outno == 27 ) {
		if( data )	dwRet = ubcp360_wCmdW( hDevID, 3, 0x18 );
		else		dwRet = ubcp360_wCmdW( hDevID, 3, 0x10 );
	} else if( outno == 28 ) {
		if( data )	dwRet = ubcp360_wCmdW( hDevID, 3, 0x19 );
		else		dwRet = ubcp360_wCmdW( hDevID, 3, 0x11 );
	} else {
		dwRet = ILL_PRM;
	}

	return dwRet;
}

//
// [ǧvZ
// 	F[g
//		F
//		Feg
//		Fek
//		F`
//		F\
//
DWORD hubcp364_CalAccRate(DWORD* rate, DWORD dwtime, DWORD fh, DWORD fl, WORD pro, WORD s)
{
	double	dblData;
	double	dblTime;
	DWORD	accrate;

	if(!fh)			return ILL_PRM;
	if(!fl)			return ILL_PRM;
	if(fh <= fl)	return ILL_PRM;
	if(!dwtime)		return ILL_PRM;

	dblTime = (double)dwtime / 1000;		// (b)

	if(s) {
	// ̂r[g:PRUR = 4915200 * ( / (FH - FL + 2 * US)) - 1)
		dblData = dblTime / (fh - fl + 2 * s);
		dblData = 4915200 * dblData - 1;
		accrate = (DWORD)dblData;
	} else {
		if(pro) {
		// ̂Ȃr[g:PRUR = 2457600 * ( / (FH - FL)) - 1)
			dblData = dblTime / (fh - fl);
			dblData = 2457600 * dblData - 1;
			accrate = (DWORD)dblData;
		} else {
		// [g:PRUR = 4915200 * ( / (FH - FL)) - 1)
			dblData = dblTime / (fh - fl);
			dblData = 4915200 * dblData - 1;
			accrate = (DWORD)dblData;
		}
	}
	if((accrate > 0xffff) || (!accrate)) 		return ILL_PRM;
	
	*rate = accrate;
	return 0;
}
