//
// s0_index.c
//
#include <windows.h>
#include "resource.h"
#include "hubr1040.h"
#include "hubcp360.h"
#include "hubcp36l.h"
#include "subcp3600.h"

LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );
void MainLoad( HWND );

//
// register main window calss
//
BOOL InitApplication( HINSTANCE hInstance )
{
	WNDCLASSEX  wc ;

	if( hInstance )	{
		// EBhENX`
		wc.style		 =	CS_HREDRAW | CS_VREDRAW;			// EBhE̎(TCYύXĕ`)
		wc.lpfnWndProc	 =	(WNDPROC)WndProc;					// EChE֐̃AhX
		wc.cbClsExtra	 =	0;									// ̑̃NX
		wc.cbWndExtra	 =	DLGWINDOWEXTRA;						// ̑̃EBhE
		wc.hInstance	 =	hInstance;							// ̃CX^X̃nh
		wc.hIcon		 =	LoadIcon(NULL, IDI_APPLICATION);	// WACR̃nh
		wc.hCursor		 =	LoadCursor(NULL, IDC_ARROW);		// }EXJ[\̃nh
		wc.hbrBackground =	(HBRUSH)(COLOR_BTNFACE + 1);		// EBhE̔wiF({^̕\ʂ̉e)
		wc.lpszMenuName	 =	NULL;								// Cj[̖O
		wc.lpszClassName =	"MENU";								// EBhENX̖O
		wc.cbSize		 =	sizeof(WNDCLASSEX);					// WNDCLASSEX\̂̃TCYݒ
		wc.hIconSm		 =	LoadIcon(NULL, IDI_WINLOGO);		// X[ACR		
	}
	return( RegisterClassEx(&wc) ) ;							// WNDCLASS̓o^
}


//
// careate main window
//
HWND InitInstance( HINSTANCE gInstance, int nCmdShow )
{
	HWND hWnd ;

	hWnd = CreateDialog( gInstance, "IDD_0INX", 0, NULL ) ;

	return hWnd ;
}


//
// WinMain
//
int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,	LPSTR lpCmdLine, int nCmdShow )
{
	MSG		msg;
	HWND	hWnd;

	// register main window class
	if( !InitApplication( hInstance ) )				return FALSE;

	// create main window
	if(!(hWnd = InitInstance(hInstance, nCmdShow)))	return FALSE;

	if( hWnd != NULL ) {
		gWnd  = hWnd;
		gInst = hInstance;
		MainLoad( hWnd );
		ShowWindow( hWnd, nCmdShow );
		UpdateWindow( hWnd );
	}
	
	// dispatch messages
	while(GetMessage(&msg, NULL, 0, 0)) {
		if(!IsDialogMessage( hWnd, &msg )) {
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}
	return msg.wParam;
}

//
// user menu
//
LRESULT userMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	switch( wParam ) {
		// foCX擾
		case IDC_RD_DEV:	
			gDlg = CreateDialog( gInst, "IDD_1DEV", hWnd,(DLGPROC)devProc );
			ShowWindow( gWnd, SW_HIDE );
			break;

		// _A
		case IDC_RD_ORG:
			// foCX
			// _A@̏l̓ZT+GR[__A(OLS ono)
			if(!iniDev( hWnd )) {
				// _Ã_CAO쐬
				gDlg = CreateDialog( gInst, "IDD_2ORG", hWnd,(DLGPROC)orgProc );
				// C̃EBhEB
				ShowWindow( gWnd, SW_HIDE );
			}
			break;

		// A蓮
		case IDC_RD_CNT:
			// foCX
			if(!iniDev( hWnd )) {
				// A蓮̃_CAO쐬
				gDlg = CreateDialog( gInst, "IDD_3CNT", hWnd,(DLGPROC)cntProc );
				// C̃EBhEB
				ShowWindow( gWnd, SW_HIDE );
			}
			break;

		// ʒuߓ
		case IDC_RD_POS:
			// foCX
			if(!iniDev( hWnd )) {
				// ʒuߓ̃_CAO쐬
				gDlg = CreateDialog( gInst, "IDD_4POS", hWnd,(DLGPROC)posProc );
				// C̃EBhEB
				ShowWindow(gWnd, SW_HIDE);
			}
			break;

		// ԓ
		case IDC_RD_LIN:
			// foCX
			if(!iniDev( hWnd )) {
				// ԓ̃_CAO쐬
				gDlg = CreateDialog( gInst, "IDD_5LIN", hWnd,(DLGPROC)linProc );
				// C̃EBhEB
				ShowWindow(gWnd, SW_HIDE);
			}
			break;

		// ~ʕԓ
		case IDC_RD_CIR:
			// foCX
			if(!iniDev( hWnd )) {
				// ~ʕԓ̃_CAO쐬
				gDlg = CreateDialog( gInst, "IDD_6CIR", hWnd,(DLGPROC)cirProc );
				// C̃EBhEB
				ShowWindow( gWnd, SW_HIDE );
			}
			break;

		// vOI
		case IDC_RD_END:
			DestroyWindow( gWnd );
			break;

//		default:
//			return DefWindowProc( hWnd, uMessage, wParam, lParam );
	}
	return 0;
}

//
// window procedure
//
LRESULT CALLBACK WndProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	switch( uMessage ) {
		case WM_COMMAND:
			userMenu( hWnd, uMessage, wParam, lParam ); 
			break;
		case WM_CLOSE:
		case WM_DESTROY:
			PostQuitMessage( 0 );
			break;
		default:
			return DefWindowProc( hWnd, uMessage, wParam, lParam );
	}
	return 0;
}

//
// load main dialog
//
void MainLoad(HWND hWnd)
{
	// rbg}bṽ[h
	gWht = LoadBitmap( gInst, MAKEINTRESOURCE(IDB_WHT) );
	gGrn = LoadBitmap( gInst, MAKEINTRESOURCE(IDB_GRN) );
	gRed = LoadBitmap( gInst, MAKEINTRESOURCE(IDB_RED) );

	gHpcDevInfo[0].dwIoAdr = 0x0900;		// {[hx[XAhX
	gHpcDevInfo[0].dwIrqNo = 0xffffffff;	// IRQsgp
	gHpcDevInfo[0].dwBHndl = 0xffffffff;	// BRG1040nh
	hDev = 0xffffffff;						// CPDfoCXnh

	CheckDlgButton(hWnd, IDC_RD_DEV, BST_CHECKED);
}
