//
// s1_dev.c
//
#include <windows.h>
#include "resource.h"
#include "hubr1040.h"
#include "hubcp360.h"
#include "hubcp36l.h"
#include "subcp3600.h"

LRESULT devMenu( HWND, UINT, WPARAM, LPARAM );
void HexAtoL( char*, DWORD* );

BOOL CALLBACK devProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	char	szBuf[255];

	switch( uMessage ) {
		// 
		case WM_SHOWWINDOW:
			hDev = 0xffffffff;
			wsprintf( szBuf, "%x\0", gHpcDevInfo[0].dwIoAdr );
			SetDlgItemText( hWnd, IDC_EDT_ADRS, szBuf );

			// {^gp
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_OPN ), TRUE );
			break;	

		case WM_COMMAND:
			devMenu( hWnd, uMessage, wParam, lParam ); 
			break;

		/* I */
		case WM_CLOSE:
			closeDev( hWnd );
			DestroyWindow( hWnd );					// _CAO{bNX
			ShowWindow( gWnd, SW_SHOWDEFAULT );		// C̃EBhE\
			break;

		/* I */
		case WM_DESTROY:
			gDlg = NULL;
			break;
	}
	return 0 ;
}

LRESULT devMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	DWORD		hBrg;
	DWORD		dwRet = 0;
	DWORD		dwAdrs = 0;
	DWORD		dwCnt = 0;
	char		szBuf[255];
	HUSBBRGINF	hBrgInfo[16];
	
	switch( wParam ) {
		/* foCXI[v */
		case IDC_BTN_OPN:
			dwRet = br1040_GetDeviceCount( &dwCnt );
			if( dwRet ) {
				MessageBox( hWnd, "HUSB-BRG1040܂D", "", MB_OK );
				return dwRet;
			}

			dwRet = br1040_GetDeviceInfo( &dwCnt, &hBrgInfo[0] );
			if( dwRet ) {
				MessageBox( hWnd, "HUSB-BRG1040܂D", "", MB_OK );
				return dwRet;
			}
			dwRet = br1040_OpenDevice( &hBrg, &hBrgInfo[0] );
			if( dwRet == 0 ) {
				gHpcDevInfo[0].dwBHndl = hBrg;
			} else {
				MessageBox( hWnd, "HUSB-BRG1040̃foCXI[vɎs܂D", "", MB_OK );
				return dwRet;
			}			

			/* {[hx[XAhXݒ */
			GetDlgItemText( hWnd, IDC_EDT_ADRS, szBuf, 16 );	
			HexAtoL( szBuf, &dwAdrs );			// 16i̒lϊ
			gHpcDevInfo[0].dwIoAdr = dwAdrs;	// {[hx[XAhX

			// foCXI[v
			dwRet = hubcp364_DevOpen( &hDev, &gHpcDevInfo[0] );
			if( dwRet ) {
				br1040_CloseDevice( gHpcDevInfo[0].dwBHndl );
				wsprintf( szBuf, "foCXI[vł܂.\n߂lF%04xh", dwRet );						
				MessageBox( hWnd, szBuf, "", MB_OK );
				return dwRet;
			}

			// foCXnh\
			wsprintf( szBuf, "%s%08lxh", "foCXnhF", hDev );
			SetDlgItemText( hWnd, IDC_STA_HNDL, szBuf );
			
			// ʕ\
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_OPN ), FALSE );
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_CLS ), TRUE );					
			break;

		/* foCXN[Y */
		case IDC_BTN_CLS:
			hubcp364_DevClose( hDev );						// CPDfoCXN[Y					
			br1040_CloseDevice( gHpcDevInfo[0].dwBHndl );	// BRGfoCXN[Y
			SetDlgItemText( hWnd, IDC_STA_HNDL, NULL );		// foCXnh\				

			// ʕ\
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_OPN ), TRUE );
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_CLS ), FALSE );					
			break;
	}
	return 0;
}

//	 16i̒lϊ
//	pszStr | 
//	pdwVal | l 
void HexAtoL(char * pszStr, DWORD * pdwVal)
{
	DWORD	dwVal = 0;
	char *	pszW;

	pszW = pszStr;
	while( *pszW ) {
		if	   ( *pszW >= '0' && *pszW <= '9' ) dwVal = (dwVal * 0x10)+( *pszW - '0');
		else if( *pszW >= 'a' && *pszW <= 'f' ) dwVal = (dwVal * 0x10)+((*pszW - 'a') + 10);
		else if( *pszW >= 'A' && *pszW <= 'F' ) dwVal = (dwVal * 0x10)+((*pszW - 'A') + 10);
		else	break;
		pszW++;
	}
	( *pdwVal ) = dwVal;
	return;
}