//
// s4_pos.c
//
#include <windows.h>
#include "resource.h"
#include "hubr1040.h"
#include "hubcp360.h"
#include "hubcp36l.h"
#include "subcp3600.h"

LRESULT posMenu ( HWND, UINT, WPARAM, LPARAM );
LRESULT posTimer( HWND, UINT, WPARAM, LPARAM );
void	posSts( HWND );
void	posLoad( HWND );		// ʒuߓ̃_CAO{bNX̏

WORD	gStart;					// 씻tO

BOOL CALLBACK posProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	switch( uMessage ) {
		case WM_SHOWWINDOW:
			posLoad( hWnd );
			gStart = 0;
			SetTimer( hWnd, IDD_TMR, 110, NULL );
			break ;

		case WM_COMMAND:
			posMenu( hWnd, uMessage, wParam, lParam ); 
			break;

		case WM_TIMER:
			posTimer( hWnd, uMessage, wParam, lParam ); 
			break;		

		// I
		case WM_CLOSE:
			closeDev( hWnd );				// foCXI
			KillTimer( hWnd, IDD_TMR );		// ^C}[~
			DestroyWindow( hWnd );			// _CAO{bNX
			break;

		// I
		case WM_DESTROY:
			gDlg = NULL;
			ShowWindow( gWnd, SW_SHOWDEFAULT );		// C̃EBhE\
			break;
	}
	return 0 ;
}

LRESULT posMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	DWORD	dwRet, dwFh;
	BOOL	bRet;
	char	szBuf[255];
	long	lData;
	
	switch( wParam ) {
		// ʒu
		case IDC_BTN_APOS:
			// 쑬xݒ
			dwFh = GetDlgItemInt( hWnd, IDC_EDT_FH, &bRet, FALSE ); 
			dwRet = hubcp364_WritFHSpd( hDev, 0, dwFh );
			if( dwRet ) {
				wsprintf( szBuf, "쑬xݒ͈͊Oł.\n߂lF%04xh", dwRet );
				MessageBox( hWnd, szBuf, "", MB_OK );
				break;
			}

			// ړʐݒ
			lData = GetDlgItemInt( hWnd, IDC_EDT_XEND, &bRet, TRUE ); 
			hubcp364_WritPos( hDev, 0, lData ); 

			// 샂[hݒ(ʒuߓ)
			hubcp364_WritOpeMode( hDev, 0, 0x41 );

			// X^[g
			hubcp364_AccStart( hDev, 0x01 );

			// 씻tO:
			gStart = 0;

			// ʕ\
			EnableWindow((GetDlgItem(hWnd, IDC_BTN_APOS)), FALSE);
			EnableWindow((GetDlgItem(hWnd, IDC_BTN_CPOS)), FALSE);
			EnableWindow((GetDlgItem(hWnd, IDC_BTN_CTRRST)), FALSE);
			SetDlgItemText(hWnd, IDC_STA_XERR, NULL);
			SetDlgItemText(hWnd, IDC_STA_XINT, NULL);
			break;

		// 葬ʒu
		case IDC_BTN_CPOS:
			// 쑬xݒ
			dwFh = GetDlgItemInt( hWnd, IDC_EDT_FH, &bRet, FALSE ); 
			dwRet = hubcp364_WritFHSpd( hDev, 0, dwFh );
			if( dwRet ) {
				wsprintf( szBuf, "쑬xݒ͈͊Oł.\n߂lF%04xh", dwRet );
				MessageBox( hWnd, szBuf, "", MB_OK );
				break;
			}

			// ړʐݒ
			lData = GetDlgItemInt( hWnd, IDC_EDT_XEND, &bRet, TRUE ); 
			hubcp364_WritPos( hDev, 0, lData ); 

			// 샂[hݒ(ʒuߓ)
			hubcp364_WritOpeMode( hDev, 0, 0x41 );
			
			// 쑬x葬X^[g
			hubcp364_CnstStartFH( hDev, 0x01 );
			
			// 씻tO:葬
			gStart = 1;

			// ʕ\
			EnableWindow((GetDlgItem(hWnd, IDC_BTN_APOS)), FALSE);
			EnableWindow((GetDlgItem(hWnd, IDC_BTN_CPOS)), FALSE);
			EnableWindow((GetDlgItem(hWnd, IDC_BTN_CTRRST)), FALSE);
			SetDlgItemText(hWnd, IDC_STA_XERR, NULL);
			SetDlgItemText(hWnd, IDC_STA_XINT, NULL);
			break;
				
		// JE^Zbg
		case IDC_BTN_CTRRST:
			hubcp364_WritCtr(hDev, 0, 0, 1); 
			break;				

		// ~
		case IDC_BTN_STP:
			if(gStart)	hubcp364_QuickStop( hDev, 0x01 );	// 葬ȂΑ~
			else		hubcp364_DecStop  ( hDev, 0x01 );	// ȂΌ~
			break;
			
		// ɐI
		case IDC_CHK_XELSA:
			// ELS A
			hubcp364_SetEls(hDev, 0, 1, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XELSA, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XELSB, BST_UNCHECKED);
			break;

		case IDC_CHK_XELSB:
			// ELS B
			hubcp364_SetEls(hDev, 0, 0, 0);			
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XELSA, BST_UNCHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XELSB, BST_CHECKED);
			break;

		case IDC_CHK_XALMA:
			// SVALM A
			hubcp364_SetSvAlm(hDev, 0, 1, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XALMA, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XALMB, BST_UNCHECKED);
			break;

		case IDC_CHK_XALMB:
			// SVALM B
			hubcp364_SetSvAlm(hDev, 0, 0, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XALMA, BST_UNCHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XALMB, BST_CHECKED);
			break;
		
		// T[{C^[tF[X
		case IDC_CHK_XSVON:
			// T[{I
			hubcp364_SvOn(hDev, 0x01);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XSVON, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XSVOF, BST_UNCHECKED);
			break;

		case IDC_CHK_XSVOF:
			// T[{It
			hubcp364_SvOff(hDev, 0x01);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XSVOF, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XSVON, BST_UNCHECKED);
			break;
	}
	return 0;
}


//
// user timer
//
LRESULT posTimer( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	switch( wParam ) {
		case IDD_TMR:
			posSts( hWnd );
			break;
		default:
			return DefWindowProc( hWnd, uMessage, wParam, lParam );
	}
	return 0 ;
}

//
//	Xe[^XǍ
//
void posSts( HWND hWnd )
{
	WORD	wMst,wSst,wSpd;
	DWORD	dwRet,dwErr,dwInt,dwPos;

	//  XCXe[^X̓Ǎ
	dwRet = hubcp364_ReadMainSts( hDev, 0, &wMst );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		return;
	}

	//  I
	if( wMst & 0x0030 ) {
		if( wMst & 0x0010 ) {		//  G[
			SetDlgItemText( hWnd, IDC_STA_XINT, "G[I" );			
				
			//  XG[Xe[^XǍ
			dwRet = hubcp364_ReadErrorSts( hDev, 0, &dwErr );
			if( dwErr & 0x20 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "+XELSONɂ~" );
			}
			if( dwErr & 0x40 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "-XELSONɂ~" );
			}
			if( dwErr & 0x80 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "XSVALMONɂ~" );
			}
			if( dwErr & 0x200 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "EMGONɂ~" );
			}
		} else {
			//  Cxg(~)
			//  XCxgXe[^XǍ
			dwRet = hubcp364_ReadEventSts( hDev, 0, &dwInt );
			if( dwInt & 1 ) {
				SetDlgItemText( hWnd, IDC_STA_XINT, "~" );
			}
		}
		EnableWindow((GetDlgItem( hWnd, IDC_BTN_APOS)), TRUE );
		EnableWindow((GetDlgItem( hWnd, IDC_BTN_CPOS)), TRUE );
		EnableWindow((GetDlgItem( hWnd, IDC_BTN_CTRRST)), TRUE );
	}
	
	// XTuXe[^X̓Ǎ
	dwRet = hubcp364_ReadSubSts( hDev, 0, &wSst );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		return;
	}

	//  SVON ʕ\(SVON ONFΐF\CSVON OFFFF\)
	if( wSst & 0x0001 )	
		SendDlgItemMessage( hWnd, IDC_BIT_XSON, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_BIT_XSON, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

	//  SVALM ʕ\(SVALM ONFԐF\CSVALM OFFFF\)
	if( wSst & 0x0800 )	
		SendDlgItemMessage( hWnd, IDC_BIT_XALM, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gRed );
	else				
		SendDlgItemMessage( hWnd, IDC_BIT_XALM, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

	//  +ELS ʕ\(ELS ONFԐF\CELS OFFFF\)
	if( wSst & 0x1000 )	
		SendDlgItemMessage( hWnd, IDC_BIT_XPEL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gRed );
	else				
		SendDlgItemMessage( hWnd, IDC_BIT_XPEL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

	//  -ELS ʕ\(ELS ONFԐF\CELS OFFFF\)
	if( wSst & 0x2000 )	
		SendDlgItemMessage( hWnd, IDC_BIT_XMEL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gRed );
	else				
		SendDlgItemMessage( hWnd, IDC_BIT_XMEL, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
	
	//  ݎw߈ʒu̓Ǎ
	dwRet = hubcp364_ReadCtr( hDev, 0, 1, &dwPos );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		return;
	}
		
	//  ݎw߈ʒu̕\
	SetDlgItemInt( hWnd, IDC_STA_XPOS, dwPos, TRUE );	
		
	//  ݑx̓Ǎ
	dwRet = hubcp364_ReadSpd( hDev, 0, &wSpd );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		return;
	}
	
	//  ݑx̕\
	SetDlgItemInt( hWnd, IDC_STA_XSPD, wSpd, FALSE );
}

//	ʒuߓ̃_CAO{bNX̏
void posLoad( HWND hWnd )	
{	
	// {^ݒ	
	CheckDlgButton( hWnd, IDC_CHK_XELSB, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_XALMB, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_XSVOF, BST_CHECKED );

	// 쑬xGfB^ݒ
	SetDlgItemText( hWnd, IDC_EDT_FH, "4000" );
	SendDlgItemMessage( hWnd, IDC_EDT_FH, EM_SETLIMITTEXT, 5, 0 );

	// ړʃGfB^ݒ
	SetDlgItemText( hWnd, IDC_EDT_XEND, "10000" );
	SendDlgItemMessage( hWnd, IDC_EDT_XEND, EM_SETLIMITTEXT, 8, 0 );
}