//
// s5_lin.c
//
#include <windows.h>
#include "resource.h"
#include "hubr1040.h"
#include "hubcp360.h"
#include "hubcp36l.h"
#include "subcp3600.h"

LRESULT linMenu ( HWND, UINT, WPARAM, LPARAM );
LRESULT linTimer( HWND, UINT, WPARAM, LPARAM );
void	linSts( HWND );
void	linLoad( HWND );		// ʒuߓ̃_CAO{bNX̏

BOOL CALLBACK linProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	switch( uMessage ) {
		case WM_SHOWWINDOW:
			linLoad( hWnd );
			SetTimer( hWnd, IDD_TMR, 110, NULL );
			break ;

		case WM_COMMAND:
			linMenu( hWnd, uMessage, wParam, lParam ); 
			break;

		case WM_TIMER:
			linTimer( hWnd, uMessage, wParam, lParam ); 
			break;		

		// I
		case WM_CLOSE:
			closeDev( hWnd );				// foCXI
			KillTimer( hWnd, IDD_TMR );		// ^C}[~
			DestroyWindow( hWnd );			// _CAO{bNX
			break;

		// I
		case WM_DESTROY:
			gDlg = NULL;
			ShowWindow( gWnd, SW_SHOWDEFAULT );		// C̃EBhE\
			break;
	}
	return 0 ;
}

LRESULT linMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	DWORD	dwRet, dwFh;
	BOOL	bRet;
	char	szBuf[255];
	long	lData;
	
	switch( wParam ) {
		// 
		case IDC_BTN_LIN:
			// 쑬xݒ
			dwFh = GetDlgItemInt( hWnd, IDC_EDT_FH, &bRet, FALSE ); 
			dwRet = hubcp364_WritFHSpd( hDev, 0, dwFh );
			if( dwRet ) {
				wsprintf( szBuf, "쑬xݒ͈͊Oł.\n߂lF%04xh", dwRet );
				MessageBox( hWnd, szBuf, "", MB_OK );
				break;
			}

			// ړʐݒ
			// Xړ
			lData = GetDlgItemInt( hWnd, IDC_EDT_XEND, &bRet, TRUE ); 
			hubcp364_WritPos( hDev, 0, lData ); 

			// Yړ
			lData = GetDlgItemInt( hWnd, IDC_EDT_YEND, &bRet, TRUE ); 
			hubcp364_WritPos( hDev, 1, lData ); 

			// 샂[hݒ(1)
			hubcp364_WritOpeMode( hDev, 0, 0x61 );
			hubcp364_WritOpeMode( hDev, 1, 0x61 );

			// X^[g(X-Y)
			hubcp364_AccStart( hDev, 0x03 );

			// ʕ\
			EnableWindow(GetDlgItem(hWnd, IDC_BTN_LIN), FALSE);
			SetDlgItemText(hWnd, IDC_STA_XERR, NULL);
			SetDlgItemText(hWnd, IDC_STA_YERR, NULL);
			SetDlgItemText(hWnd, IDC_STA_XINT, NULL);
			break;

		// ~
		case IDC_BTN_STP:
			hubcp364_DecStop  ( hDev, 0x03 );	// XY~
			break;
			
		// ɐI
		// X
		case IDC_CHK_XELSA:
			// ELS A
			hubcp364_SetEls(hDev, 0, 1, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XELSA, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XELSB, BST_UNCHECKED);
			break;

		case IDC_CHK_XELSB:
			// ELS B
			hubcp364_SetEls(hDev, 0, 0, 0);			
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XELSA, BST_UNCHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XELSB, BST_CHECKED);
			break;

		case IDC_CHK_XALMA:
			// SVALM A
			hubcp364_SetSvAlm(hDev, 0, 1, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XALMA, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XALMB, BST_UNCHECKED);
			break;

		case IDC_CHK_XALMB:
			// SVALM B
			hubcp364_SetSvAlm(hDev, 0, 0, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XALMA, BST_UNCHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XALMB, BST_CHECKED);
			break;

		// Y
		case IDC_CHK_YELSA:
			// ELS A
			hubcp364_SetEls(hDev, 1, 1, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_YELSA, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_YELSB, BST_UNCHECKED);
			break;

		case IDC_CHK_YELSB:
			// ELS B
			hubcp364_SetEls(hDev, 1, 0, 0);			
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_YELSA, BST_UNCHECKED);
			CheckDlgButton(hWnd, IDC_CHK_YELSB, BST_CHECKED);
			break;

		case IDC_CHK_YALMA:
			// SVALM A
			hubcp364_SetSvAlm(hDev, 1, 1, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_YALMA, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_YALMB, BST_UNCHECKED);
			break;

		case IDC_CHK_YALMB:
			// SVALM B
			hubcp364_SetSvAlm(hDev, 1, 0, 0);

			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_YALMA, BST_UNCHECKED);
			CheckDlgButton(hWnd, IDC_CHK_YALMB, BST_CHECKED);
			break;

		// T[{C^[tF[X
		// X
		case IDC_CHK_XSVON:
			// T[{I
			hubcp364_SvOn(hDev, 0x01);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XSVON, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XSVOF, BST_UNCHECKED);
			break;

		case IDC_CHK_XSVOF:
			// T[{It
			hubcp364_SvOff(hDev, 0x01);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_XSVOF, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_XSVON, BST_UNCHECKED);
			break;

		// Y
		case IDC_CHK_YSVON:
			// T[{I
			hubcp364_SvOn(hDev, 0x02);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_YSVON, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_YSVOF, BST_UNCHECKED);
			break;

		case IDC_CHK_YSVOF:
			// T[{It
			hubcp364_SvOff(hDev, 0x02);
			
			// ʕ\
			CheckDlgButton(hWnd, IDC_CHK_YSVOF, BST_CHECKED);
			CheckDlgButton(hWnd, IDC_CHK_YSVON, BST_UNCHECKED);
			break;
	}
	return 0;
}

//
// user timer
//
LRESULT linTimer( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	switch( wParam ) {
		case IDD_TMR:
			linSts( hWnd );
			break;
		default:
			return DefWindowProc( hWnd, uMessage, wParam, lParam );
	}
	return 0 ;
}

//
//	Xe[^XǍ
//
void linSts( HWND hWnd )
{
	WORD	wAx,wMst,wSst,wSpd;
	DWORD	dwRet,dwErr,dwInt,dwPos;

	//  XCXe[^X̓Ǎ
	dwRet = hubcp364_ReadMainSts( hDev, 0, &wMst );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		return;
	}

	//  I
	if( wMst & 0x0030 ) {
		if( wMst & 0x0010 ) {		//  G[
			SetDlgItemText( hWnd, IDC_STA_XINT, "G[I" );			
				
			//  XG[Xe[^XǍ
			dwRet = hubcp364_ReadErrorSts( hDev, 0, &dwErr );
			if( dwErr & 0x20 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "+XELSONɂ~" );
			}
			if( dwErr & 0x40 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "-XELSONɂ~" );
			}
			if( dwErr & 0x80 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "XSVALMONɂ~" );
			}
			if( dwErr & 0x200 ) {
				SetDlgItemText( hWnd, IDC_STA_XERR, "EMGONɂ~" );
			}
			if( dwErr & 0x2000 ) {
				//  YG[Xe[^XǍ
				dwRet = hubcp364_ReadErrorSts( hDev, 1, &dwErr );
				if( dwErr & 0x20 ) {
					SetDlgItemText( hWnd, IDC_STA_XERR, "+YELSONɂ~" );
				}
				if( dwErr & 0x40 ) {
					SetDlgItemText( hWnd, IDC_STA_XERR, "-YELSONɂ~" );
				}
				if( dwErr & 0x80 ) {
					SetDlgItemText( hWnd, IDC_STA_XERR, "YSVALMONɂ~" );
				}
			}
		} else {
			//  Cxg(~)
			//  XCxgXe[^XǍ
			dwRet = hubcp364_ReadEventSts( hDev, 0, &dwInt );
			if( dwInt & 1 ) {
				SetDlgItemText( hWnd, IDC_STA_XINT, "~" );
			}
		}
		EnableWindow((GetDlgItem(hWnd, IDC_BTN_LIN)), TRUE);
	}
	
	for( wAx = 0; wAx < 2;  wAx++ ) {
		// TuXe[^X̓Ǎ
		dwRet = hubcp364_ReadSubSts( hDev, wAx, &wSst );
		if( dwRet ) {
			KillTimer( hWnd, IDD_TMR );
			return;
		}

		//  SVON ʕ\(SVON ONFΐF\CSVON OFFFF\)
		if( wSst & 0x0001 )	
			SendDlgItemMessage( hWnd, IDC_BIT_XSON + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_BIT_XSON + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

		//  SVALM ʕ\(SVALM ONFԐF\CSVALM OFFFF\)
		if( wSst & 0x0800 )	
			SendDlgItemMessage( hWnd, IDC_BIT_XALM + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gRed );
		else				
			SendDlgItemMessage( hWnd, IDC_BIT_XALM + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

		//  +ELS ʕ\(ELS ONFԐF\CELS OFFFF\)
		if( wSst & 0x1000 )	
			SendDlgItemMessage( hWnd, IDC_BIT_XPEL + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gRed );
		else				
			SendDlgItemMessage( hWnd, IDC_BIT_XPEL + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

		//  -ELS ʕ\(ELS ONFԐF\CELS OFFFF\)
		if( wSst & 0x2000 )	
			SendDlgItemMessage( hWnd, IDC_BIT_XMEL + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gRed );
		else				
			SendDlgItemMessage( hWnd, IDC_BIT_XMEL + wAx * 100, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		
		//  ݎw߈ʒu̓Ǎ
		dwRet = hubcp364_ReadCtr( hDev, wAx, 1, &dwPos );
		if( dwRet ) {
			KillTimer( hWnd, IDD_TMR );
			return;
		}
			
		//  ݎw߈ʒu̕\
		SetDlgItemInt( hWnd, IDC_STA_XPOS + wAx * 100, dwPos, TRUE );
	}
			
	//  ݑx̓Ǎ
	dwRet = hubcp364_ReadSpd( hDev, 0, &wSpd );
	if( dwRet ) {
		KillTimer( hWnd, IDD_TMR );
		return;
	}
	
	//  ݑx̕\
	SetDlgItemInt( hWnd, IDC_STA_XSPD, wSpd, FALSE );
}

//	ԓ̃_CAO{bNX̏
void linLoad( HWND hWnd )	
{	
	// {^ݒ	
	CheckDlgButton( hWnd, IDC_CHK_XELSB, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_XALMB, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_XSVOF, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_YELSB, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_YALMB, BST_CHECKED );
	CheckDlgButton( hWnd, IDC_CHK_YSVOF, BST_CHECKED );

	// I_ʒuGfB^ݒ
	SetDlgItemText( hWnd, IDC_EDT_XEND, "10000" );
	SendDlgItemMessage( hWnd, IDC_EDT_XEND, EM_SETLIMITTEXT, 8, 0 );
	SetDlgItemText( hWnd, IDC_EDT_YEND, "5000");
	SendDlgItemMessage( hWnd, IDC_EDT_YEND, EM_SETLIMITTEXT, 8, 0 );

	// 쑬xGfB^ݒ
	SetDlgItemText( hWnd, IDC_EDT_FH, "4000" );
	SendDlgItemMessage( hWnd, IDC_EDT_FH, EM_SETLIMITTEXT, 5, 0 );
}
